-- Choose ONE style you like or make your own. (true/false)
local styleBlizzard = false -- Simply, without artworks.
local styleWavelet = false -- Dedicated to the rBars.
local styleCalm = true -- May be boring but I like it.

-- Show the bag buttons or not. (true/false)
-- It will be placed under the backpack. (not work with styleBlizzard)
local bagButtons = false

-- Show the statsBar or not. (true/false)
-- It will be placed beside the main actionbar. (not work with styleBlizzard)
local statsBar = false

-- Adjust here to make it fit with your teste and your UI scale.
local scale = 0.95

-- That's all of config we have but feel free to edit below as you like. ;)


-- verification.
if ( styleBlizzard ) then
	styleWavelet = nil
	styleCalm = nil
	bagButtons = nil
	statsBar = nil
end
if ( styleWavelet ) then
	styleCalm = nil
end

-- local setup.
local _G = getfenv(0)
local fake = function() end

local width = floor((styleBlizzard and MainMenuBarBackpackButton:GetRight() or ActionButton12:GetRight()) + ActionButton8:GetLeft() + 12 ) -- to be the MainMenuBar's width.
local height = 1 -- to be the MainMenuExpBar/ReputationWatchBar's height.
local wide = 26
local narrow = 17

local artworks = {
	MainMenuBarTexture0,
	MainMenuBarTexture1,
	MainMenuBarTexture2,
	MainMenuBarTexture3,

	MainMenuBarLeftEndCap,
	MainMenuBarRightEndCap,

	MainMenuBarPageNumber,

	ActionBarUpButton,
	ActionBarDownButton,

	MainMenuBarMaxLevelBar,

	MainMenuXPBarTexture0,
	MainMenuXPBarTexture1,
	MainMenuXPBarTexture2,
	MainMenuXPBarTexture3,

	ReputationWatchBarTexture0,
	ReputationWatchBarTexture1,
	ReputationWatchBarTexture2,
	ReputationWatchBarTexture3,

	ReputationXPBarTexture0,
	ReputationXPBarTexture1,
	ReputationXPBarTexture2,
	ReputationXPBarTexture3,

	BonusActionBarTexture0,
	BonusActionBarTexture1,

	ShapeshiftBarLeft,
	ShapeshiftBarMiddle,
	ShapeshiftBarRight,

	SlidingActionBarTexture0,
	SlidingActionBarTexture1,

	PossessBackground1,
	PossessBackground2,

	MainMenuExpBar,
	ReputationWatchBar,
	ExhaustionTick,
}

local bars = {
	MainMenuBar,
	MultiBarBottomLeft,
	MultiBarBottomRight,
	MultiBarRight,
	MultiBarLeft,
}

local bags = {
	MainMenuBarBackpackButton,
	CharacterBag0Slot,
	CharacterBag1Slot,
	CharacterBag2Slot,
	CharacterBag3Slot,
	KeyRingButton,
}

local micros = {
	CharacterMicroButton,
	SpellbookMicroButton,
	TalentMicroButton,
	AchievementMicroButton,
	QuestLogMicroButton,
	SocialsMicroButton,
	PVPMicroButton,
	LFGMicroButton,
	MainMenuMicroButton,
	HelpMicroButton,
}


-- Hook BonusActionBarFrame's hide/show events so we can hide/show ActionButtons as appropriate.
local BonusActionBarFrame_OnShow, BonusActionBarFrame_OnHide = BonusActionBarFrame:GetScript("OnShow"), BonusActionBarFrame:GetScript("OnHide")
BonusActionBarFrame:SetScript("OnShow", function(...)
	for i=1, 12 do
		local actionButton = _G["ActionButton" .. i]
		actionButton:SetAlpha(0)
	end
	return BonusActionBarFrame_OnShow and BonusActionBarFrame_OnShow(...)
end)
BonusActionBarFrame:SetScript("OnHide", function(...)
	for i=1, 12 do
		local actionButton = _G["ActionButton" .. i]
		actionButton:SetAlpha(1)
	end
	return BonusActionBarFrame_OnHide and BonusActionBarFrame_OnHide(...)
end)


-- Post hook ReputationWatchBar_Update function so we can relocate these bars as we want.
local ReputationWatchBar_Update_Orig = ReputationWatchBar_Update
local function ReputationWatchBar_Update_PostHook(newLevel, ...)
	if ( not newLevel ) then
		newLevel = UnitLevel("player")
	end

	-- this will not work. because the function can not wait for the actual change. it may be 17 or 26 but can be changed by patchs to come.
	-- local gap = floor(MultiBarBottomLeftButton1:GetBottom() - ActionButton1:GetTop() + 0.5)

	ReputationWatchStatusBar:SetHeight(height)

	if ( newLevel < MAX_PLAYER_LEVEL ) then

		if ( ReputationWatchBar:IsShown() ) then
			ReputationWatchBar:ClearAllPoints()
			ReputationWatchBar:SetPoint("LEFT", ActionButton1, "TOPLEFT", 0, wide / 3 * 2)
			ReputationWatchStatusBarText:ClearAllPoints()
			ReputationWatchStatusBarText:SetPoint("RIGHT", ReputationWatchBarOverlayFrame, -wide * 2, 1)

			MainMenuExpBar:ClearAllPoints()
			MainMenuExpBar:SetPoint("LEFT", ActionButton1, "TOPLEFT", 0, wide / 3)
			MainMenuBarExpText:ClearAllPoints()
			MainMenuBarExpText:SetPoint("LEFT", MainMenuExpBar, wide * 2, 1)
		else
			MainMenuExpBar:ClearAllPoints()
			MainMenuExpBar:SetPoint("LEFT", ActionButton1, "TOPLEFT", 0, narrow / 2)
			MainMenuBarExpText:ClearAllPoints()
			MainMenuBarExpText:SetPoint("CENTER", MainMenuExpBar, 0, 1)
		end
	else
		ReputationWatchBar:ClearAllPoints()
		ReputationWatchBar:SetPoint("LEFT", ActionButton1, "TOPLEFT", 0, narrow / 2)
		ReputationWatchStatusBarText:ClearAllPoints()
		ReputationWatchStatusBarText:SetPoint("CENTER", ReputationWatchBarOverlayFrame, 0, 1)
	end

	return ...
end
function ReputationWatchBar_Update(newLevel, ...)
	return ReputationWatchBar_Update_PostHook(newLevel, ReputationWatchBar_Update_Orig(newLevel, ...))
end


-- bagButtons/statsBar's setup.
local function bagButtons_OnLoad()
	MainMenuBarBackpackButton:ClearAllPoints()
	-- this will not work.
--	 MainMenuBarBackpackButton:SetPoint("RIGHT", ContainerFrame1MoneyFrame, -floor(ContainerFrame1MoneyFrame:GetRight() - ContainerFrame1MoneyFrameCopperButton:GetRight() + 0.5), 0)
--	 MainMenuBarBackpackButton:SetPoint("BOTTOM", UIParent, 0, ActionButton1:GetBottom())
	MainMenuBarBackpackButton:SetPoint("RIGHT", ContainerFrame1MoneyFrame, -13, 0)
	MainMenuBarBackpackButton:SetPoint("BOTTOM", UIParent, 0, 4)

	-- Hook ContainerFrame1's hide/show events so we can hide/show MainMenuBarbagButtons as appropriate.
	-- Or ContainerFrame1MoneyFrame to work only with MainMenuBarBackpackButton ... ?
	local showContainerFrame1, hideContainerFrame1 = ContainerFrame1:GetScript("OnShow"), ContainerFrame1:GetScript("OnHide")
	ContainerFrame1:SetScript("OnShow", function(...)
		for _, v in pairs(bags) do
			v:Show()
		end
		return showContainerFrame1 and showContainerFrame1(...)
	end)
	ContainerFrame1:SetScript("OnHide", function(...)
		for _, v in pairs(bags) do
			v:Hide()
		end
		return hideContainerFrame1 and hideContainerFrame1(...)
	end)

	-- To prevent KeyRingButton from being shown alone.
	local showKeyRingButton = KeyRingButton:GetScript("OnShow")
	KeyRingButton:SetScript("OnShow", function(self, ...)
		if ( not MainMenuBarBackpackButton:IsShown() ) then
			self:Hide()
		end
		return showKeyRingButton and showKeyRingButton(self, ...)
	end)
end

local function statsBar_OnUpdate(self, elapsed)
	if ( MainMenuBarPerformanceBar.updateInterval > 0 ) then
		MainMenuBarPerformanceBar.updateInterval = MainMenuBarPerformanceBar.updateInterval - elapsed
	else
		MainMenuBarPerformanceBar.updateInterval = PERFORMANCEBAR_UPDATE_INTERVAL -- 10
		local _, _, latency = GetNetStats()
		if ( latency > PERFORMANCEBAR_MEDIUM_LATENCY ) then -- 600
			MainMenuBarPerformanceBar:SetVertexColor(1, 0, 0)
		elseif ( latency > PERFORMANCEBAR_LOW_LATENCY ) then -- 300
			MainMenuBarPerformanceBar:SetVertexColor(1, 1, 0)
		else
			MainMenuBarPerformanceBar:SetVertexColor(0, 1, 0)
		end
	end
end

local function statsBar_OnLoad(self)
	MainMenuBarPerformanceBar:SetParent(MainMenuBarArtFrame)
	MainMenuBarPerformanceBar:ClearAllPoints()
	MainMenuBarPerformanceBar:SetPoint("TOP", MultiBarBottomLeftButton12, "TOPRIGHT", wide / 2, -36 * 2 / 3)
	MainMenuBarPerformanceBar:SetPoint("BOTTOM", ActionButton12, "BOTTOMRIGHT", wide / 2, 0)
	MainMenuBarPerformanceBar:SetWidth(height)

	MainMenuBarPerformanceBar.updateInterval = 0
	self:SetScript("OnUpdate", statsBar_OnUpdate)

	-- To prevent MainMenuBarPerformanceBar from being moved. We will not see MainMenuMicroButton anyway.
	function MainMenuMicroButton_SetPushed()
		return
	end
	function MainMenuMicroButton_SetNormal()
		return
	end
end


-- style's setup.
local function styleCommon_OnLoad()
	MainMenuBar:EnableMouse(false)

	MainMenuExpBar:SetWidth(width)
	MainMenuExpBar:SetHeight(height)
	local fontFile, fontHeight, fontFlags = MainMenuBarExpText:GetFont()
	MainMenuBarExpText:SetFont(fontFile, floor(fontHeight / scale + 0.5), fontFlags)
	ExhaustionLevelFillBar:SetHeight(height)

	ReputationWatchBar:SetWidth(width)
	ReputationWatchBar:SetHeight(height)
	ReputationWatchStatusBar:SetWidth(width)
	fontFile, fontHeight, fontFlags = ReputationWatchStatusBarText:GetFont()
	ReputationWatchStatusBarText:SetFont(fontFile, floor(fontHeight / scale + 0.5), fontFlags)
	fontFile, fontHeight, fontFlags = nil, nil, nil
end

local function styleBlizzard_OnLoad()
	bags = nil
	micros = nil
end

local function styleWavelet_OnLoad()
	MainMenuBar:SetWidth(width)

	ActionButton1:ClearAllPoints()
	ActionButton1:SetPoint("BOTTOMLEFT", MainMenuBarArtFrame, 0, 4)

	BonusActionButton1:ClearAllPoints()
	BonusActionButton1:SetPoint("BOTTOMLEFT", ActionButton1)

	MultiBarBottomRightButton1:ClearAllPoints()
	MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", MultiBarBottomLeftButton1, "TOPLEFT", 0, narrow)

	ShapeshiftButton1:ClearAllPoints()
	ShapeshiftButton1:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", narrow, narrow)
	ShapeshiftButton1.SetPoint = fake

	PetActionButton1:ClearAllPoints()
	PetActionButton1:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", narrow, narrow)
	-- PetActionButton1.SetPoint = fake

	PossessButton1:ClearAllPoints()
	PossessButton1:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", narrow, narrow)
	-- PossessButton1.SetPoint = fake

	for _, v in pairs(bags) do
		v:Hide()
	end

	for _, v in pairs(micros) do
		v:Hide()
		v.Show = fake
	end
	micros = nil

	for _, v in pairs ({
		"MultiBarRight",
		"MultiBarBottomRight",
		"ShapeshiftBarFrame",
		"PossessBarFrame",
		"CONTAINER_OFFSET_Y",
		"BATTLEFIELD_TAB_OFFSET_Y",
		"PETACTIONBAR_YPOS",
	}) do
		UIPARENT_MANAGED_FRAME_POSITIONS[v] = nil
	end
end

local function styleCalm_OnLoad()
	MainMenuBar:SetWidth(width)

	ActionButton1:ClearAllPoints()
	ActionButton1:SetPoint("BOTTOMLEFT", MainMenuBarArtFrame, 0, 4)

	BonusActionButton1:ClearAllPoints()
	BonusActionButton1:SetPoint("BOTTOMLEFT", ActionButton1)

	MultiBarBottomRightButton1:ClearAllPoints()
	MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", MultiBarBottomLeftButton12, "BOTTOMRIGHT", wide, 0)
-- ٹ
--	MultiBarBottomRightButton7:ClearAllPoints()
--	MultiBarBottomRightButton7:SetPoint("BOTTOMLEFT", ActionButton12, "BOTTOMRIGHT", wide, 0)
-- ٷ
	MultiBarBottomRightButton1:ClearAllPoints()
	MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", ActionButton12, "BOTTOMRIGHT", wide, 0)

	for _, v in pairs(bags) do
		v:Hide()
	end

	for _, v in pairs(micros) do
		v:Hide()
		v.Show = fake
	end
	micros = nil

	for k, v in pairs({ -- just a reference for me.
		-- "MultiBarBottomLeft",
		"MultiBarRight",
		-- "VoiceChatTalkers",
		-- "GroupLootFrame1",
		-- "TutorialFrameParent",
		-- "CastingBarFrame",
		-- "ChatFrame1",
		-- "ChatFrame2",
		-- "ShapeshiftBarFrame",
		-- "PossessBarFrame",
		-- "CONTAINER_OFFSET_X",
		"CONTAINER_OFFSET_Y",
		"BATTLEFIELD_TAB_OFFSET_Y",
		-- "PETACTIONBAR_YPOS",
	}) do
		UIPARENT_MANAGED_FRAME_POSITIONS[v] = nil
	end
end


local function f_OnEvent(self)
	styleCommon_OnLoad()

	if ( styleBlizzard ) then
		styleBlizzard_OnLoad()
	elseif ( styleWavelet ) then
		styleWavelet_OnLoad()
	elseif ( styleCalm ) then
		styleCalm_OnLoad()
	end

	if ( bagButtons ) then
		bagButtons_OnLoad()
	else
		bags = nil
	end

	if ( statsBar ) then
		statsBar_OnLoad(self)
	end

	for k, v in pairs(artworks) do
		v:Hide()
		if ( k > 9 ) then
			v.Show = fake
		end
	end
	artworks = nil

	for _, v in pairs(bars) do
		v:SetScale(scale)
	end
	bars = nil

	self:UnregisterAllEvents()
	self:SetScript("OnEvent", nil)
end


local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_LOGIN")
f:SetScript("OnEvent", f_OnEvent)
